require_relative '../../spec/spec_helper'

module MdrTest
  class MultiPartQueryApi
    include RSpec::Expectations
    include RSpec::Matchers
    def initialize
      super
    end

    def poll_async_preview_api_response_status(id, service, headers)
      wrap_request do
        variables = {
          'statusInput': {
            'asyncPreviewId': id
          }
        }
        graphql url(service: service),
                format_request(
                  :asyncPreviewFlexReportResponseStatus,
                  service: service
                ),
                variables, headers
        expect_success_graphql
        check(:asyncPreviewFlexReportResponseStatus, service: service)
      end
      if json_body[:data][:asyncPreviewFlexReportResponseStatus][:status].eql? 'FAILED'
        raise("Error Occurred while fetching asyncPreviewFlexReportResponseStatus with error message #{json_body[:data][:asyncPreviewFlexReportResponseStatus][:message]}")
      end
      @json_body
    end
  end
end
