require_relative '../../spec/spec_helper'

module MdrTest
  class PreparedDatasetHelper
    include RSpec::Expectations
    include RSpec::Matchers
    def initialize
      super
      @error = String.new('')
      @failures = []
      @data = []
      @hourly_relative_hours = 720
      @weekly_relative_weeks = 51
      @daily_relative_days = 63
      @monthly_relative_months = 12
    end

    def preview_flexreport_api(service, headers, queries_and_granularities)
      failures = []
      queries_and_granularities.each do |granularity_sql, sql|
        puts granularity_sql.split("_sql").first.upcase
        if ["MONTHLY", "WEEKLY", "DAILY", "HOURLY"].include?  granularity_sql.split("_sql").first.upcase
          puts granularity_sql.split("_sql").first.upcase

          case granularity_sql.split("_sql").first.upcase
          when 'HOURLY'
          end
          if granularity_sql.split("_sql").first.upcase.eql? 'HOURLY'
            relative_time = @hourly_relative_hours
          elsif granularity_sql.split("_sql").first.upcase.eql? 'WEEKLY'
            relative_time = @weekly_relative_weeks
          elsif granularity_sql.split("_sql").first.upcase.eql? 'DAILY'
            relative_time = @daily_relative_days
          elsif granularity_sql.split("_sql").first.upcase.eql? 'MONTHLY'
            relative_time = @monthly_relative_months
          else
            raise("No Matching Granualrity: For Getting Input last relative days to Query")
          end

          input_variables = {
            'queryInput': {
              'dataGranularity': granularity_sql.split("_sql").first.upcase,
              'sqlStatement': sql,
              'timeRange': {
                'last': relative_time
              },
              'limit': 100
            }
          }
          puts "Input Variables for Granularity are: #{input_variables}"
          wrap_request do
            variables = input_variables
            graphql url(service: service), format_request(:previewFlexReport, service: service), variables, headers
            expect_success_graphql
            check(:previewFlexReport, service: service)
            puts json_body
            failures << "Error Occurred Querying preview prepared dataset: on granularity: #{granularity}" if json_body.keys.include? 'errors'
          end
        end
      end
      failures
    end
  end
end