require 'spec_helper'

module MdrTest
  describe 'Mdr dataSources' do
    include_context 'request metadata'

    before(:all) do
      @failures = []
      @datasources = []
    end

    xit 'can fetch all datasources available' do
      wrap_request do
        variables = {}
        graphql url(service: service),
                format_request(
                  :dataSources,
                  service: service
                ),
                variables, headers
        expect_success_graphql
        check(:dataSources, service: service)
        json_body[:data][:dataSources].each { |datasource| @datasources << datasource if %w[AWS_CUR AZURE_COST_USAGE GCP_BILLING_EXPORT AWS_Cost_Anomaly_RCA GCP_Cost_Anomaly_RCA].include? datasource[:datasetName] }
        @datasources.each do |datasource|
          if datasource[:datasetName].eql? 'AWS_Cost_Anomaly_RCA'
            @failures << "#{datasource[:datasetName]} was expected to be VIEW}" unless datasource[:type].eql? 'VIEW'
          elsif datasource[:datasetName].eql? 'GCP_Cost_Anomaly_RCA'
            @failures << "#{datasource[:datasetName]} was expected to be VIEW}" unless datasource[:type].eql? 'VIEW'
          else
            @failures <<  "#{datasource[:datasetName]} was expected to be DATASET}" unless datasource[:type].eql? 'DATASET'
          end
        end
        @datasets_from_api_response = json_body[:data][:dataSources].map { |datasource| datasource[:datasetName] }
      end
      %w[AWS_CUR AZURE_COST_USAGE GCP_BILLING_EXPORT].each do |dataset|
        @failures << "#{dataset} is missing from api list of default datasets" unless @datasets_from_api_response.include? dataset
        wrap_request do
          variables = { dataset: dataset } if %w[AWS_CUR AZURE_COST_USAGE GCP_BILLING_EXPORT].include? dataset
          variables = { dataset: dataset, type: 'VIEW' } if %w[AWS_Cost_Anomaly_RCA GCP_Cost_Anomaly_RCA].include? dataset
          graphql url(service: service),
                  format_request(
                    :dataSourceMetadata,
                    service: service
                  ),
                  variables, headers
                  expect_success_graphql
          check(:dataSourceMetadata, service: service)
        end
      end
      expect(@failures).to eq([])
    end
  end
end
